package ru.dbotthepony.mc.otm.block.entity.tech

import net.minecraft.core.BlockPos
import net.minecraft.world.entity.player.Inventory
import net.minecraft.world.entity.player.Player
import net.minecraft.world.inventory.AbstractContainerMenu
import net.minecraft.world.item.ItemStack
import net.minecraft.world.item.Items
import net.minecraft.world.level.block.state.BlockState
import ru.dbotthepony.mc.otm.block.entity.ItemJob
import ru.dbotthepony.mc.otm.block.entity.JobContainer
import ru.dbotthepony.mc.otm.block.entity.JobStatus
import ru.dbotthepony.mc.otm.block.entity.MatteryWorkerBlockEntity
import ru.dbotthepony.mc.otm.container.slotted.AutomationFilters
import ru.dbotthepony.mc.otm.container.slotted.SlottedContainer
import ru.dbotthepony.mc.otm.menu.tech.CobblerMenu
import ru.dbotthepony.mc.otm.registry.game.MBlockEntities

class CobblerBlockEntity(blockPos: BlockPos, blockState: BlockState)
	: MatteryWorkerBlockEntity<ItemJob>(MBlockEntities.COBBLESTONE_GENERATOR, blockPos, blockState, ItemJob.CODEC) {
	override fun createMenu(containerID: Int, inventory: Inventory, ply: Player): AbstractContainerMenu {
		return CobblerMenu(containerID, inventory, this)
	}

	val container = SlottedContainer.simple(CONTAINER_SIZE, AutomationFilters.ONLY_OUT.simpleProvider, ::itemContainerUpdated).also(::addDroppableContainer)
	val itemConfig = ConfigurableItemHandler(output = container)

	init {
		savetables.stateful(::container, INVENTORY_KEY)
	}

	override fun onJobFinish(status: JobStatus<ItemJob>, id: Int) {
		if (!container.fullyAddItem(status.job.itemStack)) {
			status.noItem()
		}
	}

	override fun computeNextJob(id: Int): JobContainer<ItemJob> {
		return JobContainer.success(ItemJob(ItemStack(Items.COBBLESTONE), 40.0))
	}

	companion object {
		const val CONTAINER_SIZE = 9
	}
}
